<?php

namespace PortWallet\PortWallet\Controller\Index;
 
use Magento\Framework\App\Action\Context;
 
class Ipn extends \Magento\Framework\App\Action\Action  
{
   
    protected $_checkoutSession;
    protected $_paymentMethod;
    protected $messageManager;

    public function __construct(
    \Magento\Framework\App\Action\Context $context,
    \Magento\Checkout\Model\Session $checkoutSession,
    \PortWallet\PortWallet\Model\PortPay $paymentMethod
    ) {
        $this->_paymentMethod = $paymentMethod;
        $this->_checkoutSession = $checkoutSession;
        $this->messageManager = $context->getMessageManager();

        parent::__construct($context);
    }

    public function execute($order=null)
    {    


         if (isset($_POST['amount']) && isset($_POST['invoice'])) {
             $data['amount'] = $_POST['amount'];
             $data['invoice'] = $_POST['invoice'];
             $response =  $this->_paymentMethod->ipnValidate($data);
             
             if($response->status == 200)
             {
                 
                $order=$this->_objectManager->create('\Magento\Sales\Model\Order');
                $this->_paymentMethod->createTransactionIpn($response->data,$order);

             }
         }

         else if($_REQUEST['status'] == 'ACCEPTED')
         {
               
               $redirect = $this->_objectManager->get('Magento\Store\Model\StoreManagerInterface')->getStore()->getBaseUrl()."checkout/onepage/success/";
               return $this->resultRedirectFactory->create()->setUrl($redirect);
               
         }

         else
         {

            $resultRedirect = $this->resultRedirectFactory->create();
            $this->messageManager->addError(
                    __('We can\'t process your request right now. Sorry, Payment Failed!!!.')
            );


            $redirect = $this->_objectManager->get('Magento\Store\Model\StoreManagerInterface')->getStore()->getBaseUrl()."checkout/onepage/failure/";

            $resultRedirect->setUrl($redirect);
            return $resultRedirect;      

         }




    }




   
}